Index: /branches/Operator Architecture Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.3/MainForm.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.3/MainForm.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.3/MainForm.cs	(revision 2033)
@@ -41,11 +41,11 @@
     private class Task {
       public string filename;
-      public IStorable storable;
+      public object instance;
       public IEditor editor;
 
       private Task() { }
-      public Task(string filename, IStorable storable, IEditor editor) {
+      public Task(string filename, object instance, IEditor editor) {
         this.filename = filename;
-        this.storable = storable;
+        this.instance = instance;
         this.editor = editor;
       }
@@ -154,5 +154,5 @@
       Task task = (Task)state;
       try {
-        task.storable = PersistenceManager.Load(task.filename);
+        task.instance = PersistenceManager.Load(task.filename);
       } catch (FileNotFoundException fileNotFoundEx) {
         MessageBox.Show("Sorry couldn't open file \"" + task.filename + "\".\nThe file or plugin \"" + fileNotFoundEx.FileName + "\" is not available.\nPlease make sure you have all necessary plugins installed.",
@@ -175,6 +175,6 @@
       else {
         IEditor editor = null;
-        if (task.storable != null) {
-          IEditable editable = task.storable as IEditable;
+        if (task.instance != null) {
+          IEditable editable = task.instance as IEditable;
           if (editable != null)
             editor = editable.CreateEditor();
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/AtomicOperation.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/AtomicOperation.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/AtomicOperation.cs	(revision 2033)
@@ -72,7 +72,7 @@
     /// <param name="clonedObjects">All already cloned objects. (Needed to avoid cycles.)</param>
     /// <returns>The cloned object as <see cref="AtomicOperation"/>.</returns>
-    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+    public override object Clone(IDictionary<long, object> clonedObjects) {
       AtomicOperation clone = new AtomicOperation();
-      clonedObjects.Add(Guid, clone);
+      clonedObjects.Add(clone.Id, clone);
       clone.myOperator = (IOperator)Auxiliary.Clone(Operator, clonedObjects);
       clone.myScope = (IScope)Auxiliary.Clone(Scope, clonedObjects);
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Auxiliary.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Auxiliary.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Auxiliary.cs	(revision 2033)
@@ -38,7 +38,7 @@
     /// <param name="clonedObjects">A dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
     /// <returns>The cloned object.</returns>
-    public static object Clone(IStorable obj, IDictionary<Guid, object> clonedObjects) {
+    public static object Clone(ICloneable obj, IDictionary<long, object> clonedObjects) {
       object clone;
-      if (clonedObjects.TryGetValue(obj.Guid, out clone))
+      if (clonedObjects.TryGetValue(obj.Id, out clone))
         return clone;
       else
@@ -84,47 +84,4 @@
     }
     #endregion
-
-    #region Constraint Violation Messages
-    /// <summary>
-    /// Shows a warning message box with an OK-Button, indicating that the given constraints were violated and so 
-    /// the operation could not be completed. 
-    /// </summary>
-    /// <param name="violatedConstraints">The constraints that could not be fulfilled.</param>
-    public static void ShowConstraintViolationMessageBox(ICollection<IConstraint> violatedConstraints) {
-      string message = BuildConstraintViolationMessage(violatedConstraints);
-      MessageBox.Show("The following constraints are violated. The operation could not be completed.\n\n" + message,
-                      "Constraint Violation",
-                      MessageBoxButtons.OK,
-                      MessageBoxIcon.Warning);
-    }
-    /// <summary>
-    /// Shows a question message box with a yes-no option, where to choose whether to ignore 
-    /// the given violated constraints and to complete the operation or not.
-    /// </summary>
-    /// <param name="violatedConstraints">The constraints that could not be fulfilled.</param>
-    /// <returns>The result of the choice ("Yes" = 6, "No" = 7).</returns>
-    public static DialogResult ShowIgnoreConstraintViolationMessageBox(ICollection<IConstraint> violatedConstraints) {
-      string message = BuildConstraintViolationMessage(violatedConstraints);
-      return MessageBox.Show("The following constraints are violated. Do you want to complete the operation anyhow?\n\n" + message,
-                             "Constraint Violation",
-                             MessageBoxButtons.YesNo,
-                             MessageBoxIcon.Question);
-    }
-    /// <summary>
-    /// Builds a message out of a given collection of violated constraints, 
-    /// including the constraints type and description.
-    /// </summary>
-    /// <param name="violatedConstraints">The constraints that could not be fulfilled.</param>
-    /// <returns>The message to display.</returns>
-    private static string BuildConstraintViolationMessage(ICollection<IConstraint> violatedConstraints) {
-      StringBuilder sb = new StringBuilder();
-      foreach (IConstraint constraint in violatedConstraints) {
-        sb.AppendLine(constraint.GetType().Name);
-        sb.AppendLine(constraint.Description);
-        sb.AppendLine();
-      }
-      return sb.ToString();
-    }
-    #endregion
   }
 }
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/CallGraph.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/CallGraph.cs	(revision 2033)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/CallGraph.cs	(revision 2033)
@@ -0,0 +1,29 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+
+namespace HeuristicLab.Core {
+  public class CallGraph : ItemBase, ICallGraph {
+  }
+}
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/CallNode.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/CallNode.cs	(revision 2033)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/CallNode.cs	(revision 2033)
@@ -0,0 +1,29 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+
+namespace HeuristicLab.Core {
+  public class CallNode : ItemBase, ICallNode {
+  }
+}
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/CloneableBase.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/CloneableBase.cs	(revision 2033)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/CloneableBase.cs	(revision 2033)
@@ -0,0 +1,65 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Runtime.InteropServices;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Core {
+  /// <summary>
+  /// The base class for all cloneable objects.
+  /// </summary>
+  public abstract class CloneableBase : ICloneable {
+    /// <summary>
+    /// Gets a unique id (memory address) of the current instance. The id is used to
+    /// detect, if an object has already been cloned or not.
+    /// </summary>
+    public long Id {
+      get {
+        GCHandle handle = new GCHandle();
+        handle.Target = this;
+        return GCHandle.ToIntPtr(handle).ToInt64();
+      }
+    }
+
+    /// <summary>
+    /// Clones the current instance (deep clone).
+    /// </summary>
+    /// <remarks>Uses the <see cref="Auxiliary.Clone"/> method of the class <see cref="Auxiliary"/>.</remarks>
+    /// <returns>The clone.</returns>
+    public object Clone() {
+      return Auxiliary.Clone(this, new Dictionary<long, object>());
+    }
+    /// <summary>
+    /// Clones the current instance with the <see cref="M:Activator.CreateInstance"/> 
+    /// method of <see cref="Activator"/>.
+    /// </summary>
+    /// <param name="clonedObjects">All already cloned objects.</param>
+    /// <returns>The clone.</returns>
+    public virtual object Clone(IDictionary<long, object> clonedObjects) {
+      CloneableBase clone = (CloneableBase)Activator.CreateInstance(this.GetType());
+      clonedObjects.Add(clone.Id, clone);
+      return clone;
+    }
+  }
+}
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/CompositeOperation.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/CompositeOperation.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/CompositeOperation.cs	(revision 2033)
@@ -84,7 +84,7 @@
     /// <param name="clonedObjects">A dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
     /// <returns>The cloned operation as <see cref="CompositeOperation"/>.</returns>
-    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+    public override object Clone(IDictionary<long, object> clonedObjects) {
       CompositeOperation clone = new CompositeOperation();
-      clonedObjects.Add(Guid, clone);
+      clonedObjects.Add(clone.Id, clone);
       clone.myExecuteInParallel = ExecuteInParallel;
       for (int i = 0; i < Operations.Count; i++)
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/EngineBase.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/EngineBase.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/EngineBase.cs	(revision 2033)
@@ -130,5 +130,5 @@
     /// <param name="clonedObjects">Dictionary of all already clone objects. (Needed to avoid cycles.)</param>
     /// <returns>The cloned object as <see cref="EngineBase"/>.</returns>
-    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+    public override object Clone(IDictionary<long, object> clonedObjects) {
       EngineBase clone = (EngineBase)base.Clone(clonedObjects);
       clone.myOperatorGraph = (IOperatorGraph)Auxiliary.Clone(OperatorGraph, clonedObjects);
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 2033)
@@ -113,12 +113,5 @@
       <DependentUpon>ChooseOperatorDialog.cs</DependentUpon>
     </Compile>
-    <Compile Include="ConstrainedItemBase.cs" />
-    <Compile Include="ConstrainedItemBaseView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ConstrainedItemBaseView.Designer.cs">
-      <DependentUpon>ConstrainedItemBaseView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="ConstraintEventArgs.cs" />
+    <Compile Include="CloneableBase.cs" />
     <Compile Include="AtomicOperation.cs" />
     <Compile Include="CompositeOperation.cs" />
@@ -130,4 +123,18 @@
     </Compile>
     <Compile Include="AliasEventArgs.cs" />
+    <Compile Include="CallGraph.cs" />
+    <Compile Include="CallNode.cs" />
+    <Compile Include="ParameterView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="ParameterView.Designer.cs">
+      <DependentUpon>ParameterView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Parameter.cs" />
+    <Compile Include="ParameterType.cs" />
+    <Compile Include="Interfaces\IParameter.cs" />
+    <Compile Include="Interfaces\ICallNode.cs" />
+    <Compile Include="Interfaces\ICallGraph.cs" />
+    <Compile Include="Interfaces\ICloneable.cs" />
     <Compile Include="KeyValueEventArgs.cs" />
     <Compile Include="OperatorBaseDescriptionView.cs">
@@ -155,6 +162,4 @@
     </Compile>
     <Compile Include="ExceptionEventArgs.cs" />
-    <Compile Include="Interfaces\IConstrainedItem.cs" />
-    <Compile Include="Interfaces\IConstraint.cs" />
     <Compile Include="Interfaces\IItem.cs" />
     <Compile Include="ItemBase.cs" />
@@ -248,10 +253,8 @@
     <Compile Include="Interfaces\IRandom.cs" />
     <Compile Include="OperatorGraph.cs" />
-    <Compile Include="StorableBase.cs" />
     <Compile Include="Scope.cs" />
     <Compile Include="EngineBase.cs" />
     <Compile Include="Interfaces\IEngine.cs" />
     <Compile Include="Interfaces\IOperator.cs" />
-    <Compile Include="Interfaces\IStorable.cs" />
     <Compile Include="PersistenceManager.cs" />
     <Compile Include="HeuristicLabCorePlugin.cs" />
@@ -290,10 +293,10 @@
       <SubType>Designer</SubType>
     </EmbeddedResource>
-    <EmbeddedResource Include="ConstrainedItemBaseView.resx">
-      <DependentUpon>ConstrainedItemBaseView.cs</DependentUpon>
-      <SubType>Designer</SubType>
-    </EmbeddedResource>
     <EmbeddedResource Include="ChooseTypeDialog.resx">
       <DependentUpon>ChooseTypeDialog.cs</DependentUpon>
+      <SubType>Designer</SubType>
+    </EmbeddedResource>
+    <EmbeddedResource Include="ParameterView.resx">
+      <DependentUpon>ParameterView.cs</DependentUpon>
       <SubType>Designer</SubType>
     </EmbeddedResource>
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/ICallGraph.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/ICallGraph.cs	(revision 2033)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/ICallGraph.cs	(revision 2033)
@@ -0,0 +1,29 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+
+namespace HeuristicLab.Core {
+  public interface ICallGraph : IItem {
+  }
+}
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/ICallNode.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/ICallNode.cs	(revision 2033)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/ICallNode.cs	(revision 2033)
@@ -0,0 +1,29 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+
+namespace HeuristicLab.Core {
+  public interface ICallNode : IItem {
+  }
+}
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/ICloneable.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/ICloneable.cs	(revision 2033)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/ICloneable.cs	(revision 2033)
@@ -0,0 +1,44 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+
+namespace HeuristicLab.Core {
+  /// <summary>
+  /// Interface to represent objects that are cloneable.
+  /// </summary>
+  public interface ICloneable : System.ICloneable {
+    /// <summary>
+    /// Gets a unique id representing the current object. This id is used to check, if an object has 
+    /// already been cloned (to avoid cycles).
+    /// </summary>
+    long Id { get; }
+    /// <summary>
+    /// Clones the current instance, considering already cloned objects.
+    /// </summary>
+    /// <param name="clonedObjects">All already cloned objects. (Needed to avoid cycles.)</param>
+    /// <returns>The cloned object.</returns>
+    object Clone(IDictionary<long, object> clonedObjects);
+  }
+}
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IItem.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IItem.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IItem.cs	(revision 2033)
@@ -28,14 +28,5 @@
   /// Interface to represent (almost) every HeuristicLab object (an object, an operator,...).
   /// </summary>
-  public interface IItem : IStorable, IViewable {
-    /// <summary>
-    /// Fires a new <c>Changed</c> event.
-    /// </summary>
-    void FireChanged();
-
-    /// <summary>
-    /// Occurs when the current instance has changed.
-    /// </summary>
-    event EventHandler Changed;
+  public interface IItem : ICloneable, IViewable {
   }
 }
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IOperator.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IOperator.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IOperator.cs	(revision 2033)
@@ -29,5 +29,5 @@
   /// a basic instruction of an algorithm.
   /// </summary>
-  public interface IOperator : IConstrainedItem {
+  public interface IOperator : IItem {
     /// <summary>
     /// Gets or sets the name of the current instance.
@@ -67,20 +67,4 @@
     void AddSubOperator(IOperator op);
     /// <summary>
-    /// Adds the given sub operator to the current instance if all constraints can be fulfilled.
-    /// </summary>
-    /// <param name="op">The operator to add.</param>
-    /// <returns><c>true</c> if the operator could be added without violating constraints,
-    /// <c>false</c> otherwise.</returns>
-    bool TryAddSubOperator(IOperator op);
-    /// <summary>
-    /// Adds the given sub operator to the current instance if all constraints can be fulfilled.
-    /// </summary>
-    /// <param name="op">The operator to add.</param>
-    /// <param name="violatedConstraints">Output parameter; contains all constraints that could not be
-    /// fulfilled.</param>
-    /// <returns><c>true</c> if the operator could be added without violating constraints,
-    /// <c>false</c> otherwise.</returns>
-    bool TryAddSubOperator(IOperator op, out ICollection<IConstraint> violatedConstraints);
-    /// <summary>
     /// Adds the given sub operator at a the specified <paramref name="index"/>.
     /// </summary>
@@ -89,45 +73,8 @@
     void AddSubOperator(IOperator op, int index);
     /// <summary>
-    /// Adds the given operator at the specified <paramref name="index"/> to the current instance 
-    /// if all constraints can be fulfilled.
-    /// </summary>
-    /// <param name="op">The operator to add.</param>
-    /// <param name="index">The position where to add the operator.</param>
-    /// <returns><c>true</c> if the operator could be added without violating constraints,
-    /// <c>false</c> otherwise.</returns>
-    bool TryAddSubOperator(IOperator op, int index);
-    /// <summary>
-    /// Adds the given operator at the specified <paramref name="index"/> to the current instance 
-    /// if all constraints can be fulfilled.
-    /// </summary>
-    /// <param name="op">The operator to add.</param>
-    /// <param name="index">The position where to add the operator.</param>
-    /// <param name="violatedConstraints">Output parameter; contains all constraints that could not be
-    /// fulfilled.</param>
-    /// <returns><c>true</c> if the operator could be added without violating constraints,
-    /// <c>false</c> otherwise.</returns>
-    bool TryAddSubOperator(IOperator op, int index, out ICollection<IConstraint> violatedConstraints);
-    /// <summary>
     /// Removes a sub operator at the specified <paramref name="index"/>.
     /// </summary>
     /// <param name="index">The position where to delete the operator.</param>
     void RemoveSubOperator(int index);
-    /// <summary>
-    /// Removes a sub operator at the specified <paramref name="index"/> if all constraint can be fulfilled.
-    /// </summary>
-    /// <param name="index">The position where to delete the operator.</param>
-    /// <returns><c>true</c> if the operator could be deleted without violating constraints,
-    /// <c>false</c> otherwise.</returns>
-    bool TryRemoveSubOperator(int index);
-    /// <summary>
-    /// Deletes the operator at the specified <paramref name="index"/>  
-    /// if all constraints can be fulfilled.
-    /// </summary>
-    /// <param name="index">The position where to delete the operator.</param>
-    /// <param name="violatedConstraints">Output parameter; contains all constraints that could not be
-    /// fulfilled.</param>
-    /// <returns><c>true</c> if the operator could be deleted without violating constraints,
-    /// <c>false</c> otherwise.</returns>
-    bool TryRemoveSubOperator(int index, out ICollection<IConstraint> violatedConstraints);
 
     /// <summary>
@@ -143,42 +90,8 @@
     void AddVariableInfo(IVariableInfo variableInfo);
     /// <summary>
-    /// Adds the specified variable info to the current instance, if all constraints can be fulfilled.
-    /// </summary>
-    /// <param name="variableInfo">The variable info to add.</param>
-    /// <returns><c>true</c> if the variable info could be added without violating constraints,
-    /// <c>false</c> otherwise.</returns>
-    bool TryAddVariableInfo(IVariableInfo variableInfo);
-    /// <summary>
-    /// Adds the specified variable info to the current instance, if all constraints can be fulfilled.
-    /// </summary>
-    /// <param name="variableInfo">The variable info to add.</param>
-    /// <param name="violatedConstraints">Output parameter; contains all constraints that could not be
-    /// fulfilled.</param>
-    /// <returns><c>true</c> if the variable info could be added without violating constraints,
-    /// <c>false</c> otherwise.</returns>
-    bool TryAddVariableInfo(IVariableInfo variableInfo, out ICollection<IConstraint> violatedConstraints);
-    /// <summary>
     /// Removes the variable info with the given formal name.
     /// </summary>
     /// <param name="formalName">The formal name of the variable info to remove.</param>
     void RemoveVariableInfo(string formalName);
-    /// <summary>
-    /// Deletes the variable info with the given formal name, 
-    /// if all constraints can be fulfilled.
-    /// </summary>
-    /// <param name="formalName">The formal name of the variable info to remove.</param>
-    /// <returns><c>true</c> if the variable info could be deleted without violating constraints,
-    /// <c>false</c> otherwise.</returns>
-    bool TryRemoveVariableInfo(string formalName);
-    /// <summary>
-    /// Deletes the variable info with the given formal name, 
-    /// if all constraints can be fulfilled.
-    /// </summary>
-    /// <param name="formalName">The formal name of the variable info to remove.</param>
-    /// <param name="violatedConstraints">Output parameter; contains all constraints that could not be
-    /// fulfilled.</param>
-    /// <returns><c>true</c> if the variable info could be deleted without violating constraints,
-    /// <c>false</c> otherwise.</returns>
-    bool TryRemoveVariableInfo(string formalName, out ICollection<IConstraint> violatedConstraints);
 
     /// <summary>
@@ -194,45 +107,9 @@
     void AddVariable(IVariable variable);
     /// <summary>
-    /// Adds the specified <paramref name="variable"/> to the current instance if all constraints can
-    /// be fulfilled.
-    /// </summary>
-    /// <param name="variable">The variable to add.</param>
-    /// <returns><c>true</c> if the variable could be added without violating constraints,
-    /// <c>false</c> otherwise.</returns>
-    bool TryAddVariable(IVariable variable);
-    /// <summary>
-    /// Adds the specified <paramref name="variable"/> to the current instance if all constraints can
-    /// be fulfilled.
-    /// </summary>
-    /// <param name="variable">The variable to add.</param>
-    /// <param name="violatedConstraints">Output parameter; contains all constraints that could 
-    /// not be fulfillled.</param>
-    /// <returns><c>true</c> if the variable could be added without violating constraints,
-    /// <c>false</c> otherwise.</returns>
-    bool TryAddVariable(IVariable variable, out ICollection<IConstraint> violatedConstraints);
-    /// <summary>
     /// Deletes the variable with the specified <paramref name="name"/>.
     /// </summary>
     /// <param name="name">The name of the variable to delete.</param>
     void RemoveVariable(string name);
-    /// <summary>
-    /// Deletes the variable with the specified <paramref name="name"/> if all constraints can be 
-    /// fulfilled.
-    /// </summary>
-    /// <param name="name">The name of the variable to remove.</param>
-    /// <returns><c>true</c> if the variable could be deleted without violating constraints,
-    /// <c>false</c> otherwise.</returns>
-    bool TryRemoveVariable(string name);
-    /// <summary>
-    /// Deletes the variable with the specified <paramref name="name"/> if all constraints can be 
-    /// fulfilled.
-    /// </summary>
-    /// <param name="name">The name of the variable to remove.</param>
-    /// <param name="violatedConstraints">Output parameter; contains all constraints that could 
-    /// not be fulfilled.</param>
-    /// <returns><c>true</c> if the variable could be deleted without violating constraints,
-    /// <c>false</c> otherwise.</returns>
-    bool TryRemoveVariable(string name, out ICollection<IConstraint> violatedConstraints);
-    
+
     /// <inheritdoc cref="GetVariableValue(string, HeuristicLab.Core.IScope, bool)"/>
     /// <typeparam name="T">The type of the value that is searched.</typeparam>       
